<?php

require_once("lib-i18n.inc");

global $admin_logfile;

$admin_logfile = get_prefs("LogDir") . "/oasis_admin.log";
$sim_logfile   = get_prefs("LogDir") . "/oasis_sim.log";


####---------------------------------------------------------------------------
####---------------------------------------------------------------------------
function warn($msg)
{
  if($fp = fopen("php://stderr", "w"))
  {
    fputs($fp, "$msg\n");
    fclose($fp);
  }

  admin_log("WARNING: $msg");

  return 1;
}


####---------------------------------------------------------------------------
####---------------------------------------------------------------------------
function admin_log($msg)
{
  global $admin_logfile;
  global $OASISdatefmt;

  if ($OASISdatefmt == 'mdy')
    $log_msg = date('H:i:s M d, Y') . "\t" . $msg . "\n";
  if ($OASISdatefmt == 'dmy')
    $log_msg = date('H:i:s d M, Y') . "\t" . $msg . "\n";

  error_log($log_msg, 3, $admin_logfile);
}


####---------------------------------------------------------------------------
####---------------------------------------------------------------------------
function sim_log($msg)
{
  global $sim_logfile;
  global $OASISdatefmt;

  if ($OASISdatefmt == 'mdy')
    $log_msg = date('H:i:s M d, Y') . "\t" . $msg . "\n";
  if ($OASISdatefmt == 'dmy')
    $log_msg = date('H:i:s d M, Y') . "\t" . $msg . "\n";

  error_log($log_msg, 3, $sim_logfile);
}


####---------------------------------------------------------------------------
####---------------------------------------------------------------------------
function abort($msg)
{
  global $OASISmsg;

  admin_log("$OASISmsg[FATAL]: $msg");

  $admin_email = get_prefs('AdminEmail');
  mail($admin_email, "$OASISmsg[Fatal_OASIS_Error]", $msg);

  die("$msg\n");
}


?>
